#this file is part of manqod
#manqod is distributed under the CDDL licence
#the owner of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

require 'rubygems'
require 'java'
RAILS_CONNECTION_ADAPTERS = %w(jdbc)
einfo("pease run: export CLASSPATH=$(java-config --classpath jdbc-mysql)")unless ENV['CLASSPATH'].index("mysql")
module Jdbc; DriverManager = java.sql.DriverManager; Driver = com.mysql.jdbc.Driver end 
module JavaLang;include_package "java.lang";end
module JavaSql;include_package 'java.sql';end

class MySQL 
	include Eprint

	def initialize(host,user,password,dbase)
		@host=host
		@user=user
		@password=password
		@dbase=dbase
		@conn = Jdbc::DriverManager.getConnection("jdbc:mysql://#{@host}/#{@dbase}?user=#{@user}&password=#{@password}&zeroDateTimeBehavior=convertToNull&jdbcCompliantTruncation=false");
	end


	def query(sql)
		return nil if sql.nil? or sql.length ==0
		begin
			stmt = @conn.createStatement
			res = stmt.executeQuery(sql)
		rescue SQLException => err
#			case err
#				when 2006, 2013
#					einfo("connection dropped: retrying")
#					reconnect
#					retry
#				when 1062
					#duplicate
#					res=-1
#				else
					eerror("#{err} in\n#{sql}")
					raise "#{err}\n#{sql}\n"
#			end
		rescue CommunicationsException => e
					edebug("comm error")
					eerror("#{e} in\n#{sql}")
					raise "#{e}\n#{sql}\n"
		rescue =>e
					edebug("other error: #{e.class.name}")
					eerror("#{err} in\n#{sql}")
		end
		return res
	end
	
	def fetch_hash(res,with_table=false)
		begin
		data=Array.new
  	unless res.nil? 
  		while res.next do
				md=res.meta_data
				row=Hash.new
				i=1
				while i<=md.column_count do
					header=if with_table then 
						md.table_name(i)+"."+md.column_label(i)
						else 
						md.column_label(i)
					end
					row[header]=res.getString(md.column_label(i))
					i+=1
				end
				data.push(row)
			end
		end
		return data
		rescue =>e
			eerror("metadata:#{md.inspect}\nrow:#{row.inspect}\nheader:#{header.inspect},colnum:#{i}")
			eerror("error preparing the result:#{e}\n #{e.backtrace.join("\n\t")}")
		end
	end
	
	def fields(sql)
		yield nil
	end

	def qrow(sql,with_table=false)
		row=fetch_hash(query(sql),with_table).first
		return row
	end

	def rows(sql,with_table=false)
		if ret=query(sql)
			fetch_hash(ret,with_table)
		end
	end

  def escape_string(string)
  	#we do nothing yet
		string
  end

	def inspect
		"jmysql(#{@dbase})"
	end
	def to_s
		inspect
	end
end
